
/*****************************************************/
/***   Program:  Hardcore Mod Main Program         ***/
/***   By: Beancounter                             ***/
/***   Version: v1.00                              ***/
/*****************************************************/
/***   Description:  This include file is the      ***/
/***   main block for the Hardcode Mod             ***/
/***
/***   See Hardcore_Control.nss for how to Tweak   ***/
/***   the Buffs a NPC gets.                       ***/
/*****************************************************/



#include "HC_Control"


// Function Prototypes
int IsCreature();
void Hardcore_Mod();


void Hardcore_Mod()
{

     float HC_Modifier;
     
     int hp_very_high = 12;
     int hp_high = 10;
     int hp_med  = 8;
     int hp_low  = 6;
     
     float THAC0_high = 1.00;
     float THAC0_med  = 0.75;
     float THAC0_low  = 0.50;
          
     int fp_high = 10;
     int fp_med  = 8;
     int fp_low  = 6;
     int fp_very_low = 4;
     int fp_none = 0;
     
     float save_high = 1.0;
     float save_med = 0.375;
     float save_low = 0.25;
     

     float def_high = 1.00;
     float def_med  = 0.75;
     float def_low  = 0.50;

     float dmg_high = 1.00;
     float dmg_med  = 0.75;
     float dmg_low  = 0.50;
     
     int hp_modifier;
     int fp_modifier;
     float THAC0_modifier;
     
     float fort_modifier;
     float reflect_modifier;
     float will_modifier;
     
     float dmg_modifier;
     float def_modifier;
     
     
     int ability_to_increase1;
     int ability_to_increase2;
     int ability_to_increase3;
     
     int ability_increase_amount1;
     int ability_increase_amount2;
     int ability_increase_amount3;
     

       
     int HC_hp_Buff;
     int HC_THAC0_Buff;
     int HC_fp_Buff;
     
     int HC_fort_Buff;
     int HC_reflect_Buff;
     int HC_will_Buff;
     
     int HC_Def_Buff;
     int HC_Dmg_Buff;
     

     
     int nClass = GetClassByPosition(1, OBJECT_SELF);

     int NPC_AI = GetNPCAIStyle(OBJECT_SELF);
     
     //  Determine if the creature is marked as a Boss
     if(GN_GetSpawnInCondition(SW_FLAG_BOSS_AI) || NPC_AI == NPC_AISTYLE_TURTLE)
     {
          HC_Modifier          = HC_Boss_Modifier;
     }
     
     else
     {
         HC_Modifier          = HC_Base_Modifier;
     }


     int PC_Level          = GetHitDice(GetFirstPC());
     int MonsterLevel      = GetHitDice(OBJECT_SELF);
          
         
     int Adj_Needed        = FloatToInt(PC_Level * HC_Modifier);
     int Adj_Monster_Level = MonsterLevel + Adj_Needed;


     
     switch (nClass)
     {
          case CLASS_TYPE_SOLDIER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;

               def_modifier     = def_high;
               dmg_modifier     = dmg_high;
               
     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }
     
          case CLASS_TYPE_SCOUT:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_SCOUNDREL:
     	  {
     	       hp_modifier      = hp_low;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;

               def_modifier     = def_high;
               dmg_modifier     = dmg_high;
     	       
     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_JEDIGUARDIAN:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_very_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_JEDICONSULAR:
     	  {
     	       hp_modifier      = hp_low;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_med;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_JEDISENTINEL:
     	  {
     	       hp_modifier      = hp_med;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_COMBATDROID:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_EXPERTDROID:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }

          case CLASS_TYPE_MINION:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }


          case CLASS_TYPE_TECHSPECIALIST:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_none;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = 0;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = 0;
          }
     
          case CLASS_TYPE_JEDIWEAPONMASTER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_JEDIMASTER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_high;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_JEDIWATCHMAN:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_med;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_SITHMARAUDER:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_low;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_SITHLORD:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_high;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

          case CLASS_TYPE_SITHASSASSIN:
     	  {
     	       hp_modifier      = hp_high;
     	       THAC0_modifier   = THAC0_high;
               fp_modifier      = fp_med;     

               fort_modifier    = save_high;
     	       reflect_modifier = save_high;
     	       will_modifier    = save_high;
     	       
               def_modifier     = def_high;
               dmg_modifier     = dmg_high;

     	       ability_to_increase1 = ABILITY_STRENGTH;
     	       ability_to_increase2 = ABILITY_DEXTERITY;
               ability_to_increase3 = ABILITY_WISDOM;
               
               ability_increase_amount1 = Adj_Needed;
               ability_increase_amount2 = Adj_Needed;
               ability_increase_amount3 = Adj_Needed;
          }

     }
     


     

     int constitution_bonus = GetAbilityModifier(ABILITY_CONSTITUTION, OBJECT_SELF);
     int will_bonus = GetAbilityModifier(ABILITY_WISDOM, OBJECT_SELF);
     int charisma_bonus = GetAbilityModifier(ABILITY_CHARISMA, OBJECT_SELF);


    
     HC_hp_Buff      = (hp_modifier + constitution_bonus) * Adj_Needed;
     HC_fp_Buff      = (fp_modifier + will_bonus + charisma_bonus) * Adj_Needed;
     HC_THAC0_Buff   = FloatToInt(Adj_Monster_Level * THAC0_modifier) - FloatToInt(MonsterLevel * THAC0_modifier); 

     HC_fort_Buff    = FloatToInt(Adj_Monster_Level * fort_modifier) - FloatToInt(MonsterLevel * fort_modifier);
     HC_reflect_Buff = FloatToInt(Adj_Monster_Level * reflect_modifier) - FloatToInt(MonsterLevel * reflect_modifier);
     HC_will_Buff    = FloatToInt(Adj_Monster_Level * will_modifier) - FloatToInt(MonsterLevel * will_modifier);
     
     HC_Def_Buff     = FloatToInt(def_modifier * Adj_Needed);
     HC_Dmg_Buff     = FloatToInt(dmg_modifier * Adj_Needed);


     /* Adj Setting for the Tweaks from Hardcore_Control.nss */
     HC_hp_Buff      = FloatToInt(HC_hp_Buff * HC_HP_Tweak);
     HC_fp_Buff      = FloatToInt(HC_fp_Buff * HC_FP_Tweak);
     HC_THAC0_Buff   = FloatToInt(HC_THAC0_Buff * HC_THAC0_Tweak);
     HC_fort_Buff    = FloatToInt(HC_fort_Buff * HC_Save_Tweak);
     HC_reflect_Buff = FloatToInt(HC_reflect_Buff * HC_Save_Tweak);
     HC_will_Buff    = FloatToInt(HC_will_Buff * HC_Save_Tweak);
     HC_Def_Buff     = FloatToInt(HC_Def_Buff * HC_Def_Tweak);
     HC_Dmg_Buff     = FloatToInt(HC_Dmg_Buff * HC_Dmg_Tweak);
     
     ability_increase_amount1 = FloatToInt(ability_increase_amount1 * HC_Ability_Tweak);
     ability_increase_amount2 = FloatToInt(ability_increase_amount2 * HC_Ability_Tweak);
     ability_increase_amount3 = FloatToInt(ability_increase_amount3 * HC_Ability_Tweak);


     /***************************/
     /***   APPLY BUFFS       ***/
     /***************************/
     // Adj Attributes     
     if (ability_to_increase1 != 0 && ability_increase_amount1 > 0) 
     {
          AdjustCreatureAttributes(OBJECT_SELF,ability_to_increase1 ,ability_increase_amount1);
     }
     
     if (ability_to_increase2 != 0 && ability_increase_amount2 > 0) 
     {
          AdjustCreatureAttributes(OBJECT_SELF,ability_to_increase2 ,ability_increase_amount2);
     }

     if (ability_to_increase3 != 0 && ability_increase_amount3 > 0) 
     {
          AdjustCreatureAttributes(OBJECT_SELF,ability_to_increase3 ,ability_increase_amount3);
     }

     
     // Adj Vitality
     if(HC_hp_Buff > 0)
     {
          SetMaxHitPoints(OBJECT_SELF, GetMaxHitPoints(OBJECT_SELF) + HC_hp_Buff);
     }
     
     // Adj Force Points
     if(HC_fp_Buff > 0)
     {
          AddBonusForcePoints(OBJECT_SELF, HC_fp_Buff);
     }
     
     
     
     // Adj Saves
     if(HC_fort_Buff > 0)
     {
          ModifyFortitudeSavingThrowBase(OBJECT_SELF, HC_fort_Buff);
     }
     
     if(HC_reflect_Buff > 0)
     {
          ModifyReflexSavingThrowBase(OBJECT_SELF, HC_reflect_Buff);
     }
     
     if(HC_will_Buff > 0)
     {
          ModifyWillSavingThrowBase(OBJECT_SELF, HC_will_Buff);
     }
     
     
     // Adj THAC0
     if(HC_THAC0_Buff > 0)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectAttackIncrease(HC_THAC0_Buff), OBJECT_SELF);
     }
     
     // Adj AC
     if(HC_Def_Buff > 0)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectACIncrease(HC_Def_Buff), OBJECT_SELF);
     }
     
     // Adj Dmg
     if(HC_Dmg_Buff > 0)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectDamageIncrease(HC_Dmg_Buff, DAMAGE_TYPE_UNIVERSAL), OBJECT_SELF);
     }
     
     
     // Add Extra Attacks
     if(HC_Extra_Attack2 > 0 && Adj_Monster_Level >= HC_Extra_Attack2)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectModifyAttacks(2), OBJECT_SELF);
     }
     
     
     else if(HC_Extra_Attack1 > 0 && Adj_Monster_Level >= HC_Extra_Attack1)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectModifyAttacks(1), OBJECT_SELF);
     }
     
     
     // Adj AI
     if(HC_AI_Tweak != 0 && (NPC_AI == NPC_AISTYLE_DEFAULT_ATTACK || NPC_AI == NPC_AISTYLE_RANGED_ATTACK 
     			     || NPC_AI == NPC_AISTYLE_MELEE_ATTACK || NPC_AI == NPC_AISTYLE_GRENADE_THROWER))
     {
          GN_SetSpawnInCondition(SW_FLAG_BOSS_AI);

     }
     


     //  Assign Bonus Immunity
     int nRandom = Random(101);
     
     if (nRandom <= HC_Resist_Chance)
     {
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSpellImmunity(IMMUNITY_TYPE_FEAR), OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSpellImmunity(IMMUNITY_TYPE_PARALYSIS), OBJECT_SELF);
          ApplyEffectToObject(DURATION_TYPE_PERMANENT, EffectSpellImmunity(IMMUNITY_TYPE_STUN), OBJECT_SELF);
     }


     /* ADD EXTRA FEATS - THIS IS BETA ONLY, USE AT YOUR OWN RISK!! */
     /* If an Appearance Type Does not support the Combat Feat the creature will not attack correctly */
     
     int CreatureAppearance = GetAppearanceType(OBJECT_SELF);
     
     if (Adj_Monster_Level <= 6 && IsCreature() == 0 && HC_Extra_Feat != 0)     
     {
          GrantFeat(FEAT_WEAPON_FOCUS_BLASTER, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_FOCUS_BLASTER_RIFLE, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_FOCUS_HEAVY_WEAPONS, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_FOCUS_LIGHTSABER, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_FOCUS_MELEE_WEAPONS, OBJECT_SELF);
          GrantFeat(FEAT_WEAPON_FOCUS_SIMPLE_WEAPONS, OBJECT_SELF);
          GrantFeat(113, OBJECT_SELF); //DUELING
          GrantFeat(FEAT_AMBIDEXTERITY, OBJECT_SELF);
          
          if(GetRacialType(OBJECT_SELF) != RACIAL_TYPE_DROID)
          {
               GrantFeat(FEAT_CRITICAL_STRIKE, OBJECT_SELF);
               GrantFeat(FEAT_FLURRY, OBJECT_SELF);
               GrantFeat(FEAT_POWER_ATTACK, OBJECT_SELF);
               GrantFeat(FEAT_RAPID_SHOT, OBJECT_SELF);
               GrantFeat(FEAT_POWER_BLAST, OBJECT_SELF);
               GrantFeat(FEAT_SNIPER_SHOT, OBJECT_SELF);
          }    
          
          
          else if( CreatureAppearance == 56
          	|| CreatureAppearance == 66
          	|| CreatureAppearance == 460
          	|| CreatureAppearance == 461
          	|| CreatureAppearance == 557
          	|| CreatureAppearance == 577) // Only Certain Droids can use Rapid Shot
          {
               GrantFeat(FEAT_RAPID_SHOT, OBJECT_SELF);
          }
          
          
          
          
     }


     else if (Adj_Monster_Level > 6 && Adj_Monster_Level < 12 && IsCreature() == 0 && HC_Extra_Feat != 0)     
     {
     
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER_RIFLE, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_HEAVY_WEAPONS, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_LIGHTSABER, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_MELEE_WEAPONS, OBJECT_SELF);
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_SIMPLE_WEAPONS, OBJECT_SELF);
          GrantFeat(114, OBJECT_SELF); //ADVANCED DUELING
          GrantFeat(FEAT_DOUBLE_WEAPON_FIGHTING, OBJECT_SELF);
          
          if(GetRacialType(OBJECT_SELF) != RACIAL_TYPE_DROID 
             && nClass != CLASS_TYPE_COMBATDROID 
             && nClass != CLASS_TYPE_EXPERTDROID)
          {
               GrantFeat(FEAT_IMPROVED_CRITICAL_STRIKE, OBJECT_SELF);
               GrantFeat(FEAT_IMPROVED_FLURRY, OBJECT_SELF);
               GrantFeat(FEAT_IMPROVED_POWER_ATTACK, OBJECT_SELF);
               GrantFeat(FEAT_IMPROVED_RAPID_SHOT, OBJECT_SELF);
               GrantFeat(FEAT_IMPROVED_POWER_BLAST, OBJECT_SELF);
               GrantFeat(FEAT_IMPROVED_SNIPER_SHOT, OBJECT_SELF);
          }    
          
          
          else if( CreatureAppearance == 56
          	|| CreatureAppearance == 66
          	|| CreatureAppearance == 460
          	|| CreatureAppearance == 461
          	|| CreatureAppearance == 557
          	|| CreatureAppearance == 577) // Only Certain Droids can use Rapid Shot
          {
               GrantFeat(FEAT_IMPROVED_RAPID_SHOT, OBJECT_SELF);
          }




     }

     else if (Adj_Monster_Level >= 12 && IsCreature() == 0 && HC_Extra_Feat != 0)     
     {
     
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_BLASTER_RIFLE, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_HEAVY_WEAPONS, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_LIGHTSABER, OBJECT_SELF);
	  GrantFeat(FEAT_WEAPON_SPECIALIZATION_MELEE_WEAPONS, OBJECT_SELF);
          GrantFeat(FEAT_WEAPON_SPECIALIZATION_SIMPLE_WEAPONS, OBJECT_SELF);
          GrantFeat(115, OBJECT_SELF); //MASTER DUELING
          GrantFeat(FEAT_AMBIDEXTERITY, OBJECT_SELF);
          GrantFeat(FEAT_ADVANCED_DOUBLE_WEAPON_FIGHTING, OBJECT_SELF);
          
          if(GetRacialType(OBJECT_SELF) != RACIAL_TYPE_DROID
             && nClass != CLASS_TYPE_COMBATDROID 
             && nClass != CLASS_TYPE_EXPERTDROID)
          {
               GrantFeat(FEAT_MASTER_CRITICAL_STRIKE, OBJECT_SELF);
               GrantFeat(FEAT_WHIRLWIND_ATTACK, OBJECT_SELF);
               GrantFeat(FEAT_MASTER_POWER_ATTACK, OBJECT_SELF);
               GrantFeat(FEAT_MULTI_SHOT, OBJECT_SELF);
               GrantFeat(FEAT_MASTER_POWER_BLAST, OBJECT_SELF);
               GrantFeat(FEAT_MASTER_SNIPER_SHOT, OBJECT_SELF);
          }    
          
          
          else if( CreatureAppearance == 56
          	|| CreatureAppearance == 66
          	|| CreatureAppearance == 460
          	|| CreatureAppearance == 461
          	|| CreatureAppearance == 557
          	|| CreatureAppearance == 577) // Only Certain Droids can use Rapid Shot
          {
               GrantFeat(FEAT_MULTI_SHOT, OBJECT_SELF);
          }

     }






     //  Flag that the creature has been buffed
     GrantFeat(FEAT_IMPLANT_LEVEL_1, OBJECT_SELF);  

}
     
     
     
int IsCreature()
{
     int MainHandType = GetBaseItemType(GetItemInSlot(INVENTORY_SLOT_RIGHTWEAPON, OBJECT_SELF));
     int OffHandType  = GetBaseItemType(GetItemInSlot(INVENTORY_SLOT_LEFTWEAPON, OBJECT_SELF));

     if(MainHandType == BASE_ITEM_CREATURE_ITEM_SLASH 
        || MainHandType == BASE_ITEM_CREATURE_ITEM_PIERCE
     	|| MainHandType == BASE_ITEM_CREATURE_WEAPON_SL_PRC
        || OffHandType == BASE_ITEM_CREATURE_ITEM_SLASH 
        || OffHandType == BASE_ITEM_CREATURE_ITEM_PIERCE
     	|| OffHandType == BASE_ITEM_CREATURE_WEAPON_SL_PRC)
     	{
     	     return 1;
     	}
     	else 
     	{
     	     return 0;
     	}
}

     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     